<template>
  <app-layout
    v-if="user !== null"
    :user="user"
    @sign-out="logout"
    @edit-user="isUserEditing = true"
    @change-password="isPasswordChanging = true"
  >
    <router-view />

    <prime-dialog
      v-model:visible="isUserEditing"
      header="Редактирование пользователя"
      :modal="true"
    >
      <edit-user
        :is-editing-himself="true"
        :user="user"
        @close="isUserEditing = false"
        @update="user = $event"
      />
    </prime-dialog>

    <prime-dialog
      v-model:visible="isPasswordChanging"
      header="Редактирование пароля"
      :modal="true"
    >
      <change-password
        @close="isPasswordChanging = false"
      />
    </prime-dialog>
  </app-layout>
</template>

<script lang="ts">
import PrimeDialog from 'primevue/dialog/Dialog.vue';
import { defineComponent } from 'vue';
import { logout } from '@/api/handler/login';
import ChangePassword from '@/components/users/ChangePassword.vue';
import EditUser from '@/components/users/EditUser.vue';
import AppLayout from '@/layout/AppLayout.vue';
import { getUser } from './api/handler/user';
import { User } from './models/user';

interface Data {
  user: User | null;
  isUserEditing: boolean;
  isPasswordChanging: boolean;
}

export default defineComponent({
  name: 'app-middleware',
  components: {
    PrimeDialog,

    AppLayout,
    EditUser,
    ChangePassword,
  },
  data(): Data {
    return {
      user: null,
      isUserEditing: false,
      isPasswordChanging: false,
    };
  },
  async created() {
    const res = await getUser();
    if (res.__state === 'success') {
      this.user = res.data;
    } else {
      this.$router.push('/login');
    }
  },
  methods: {
    async logout() {
      const res = await logout();

      if (res.__state === 'success') {
        this.$router.push('/login');
      } else {
        this.$toast.add({ severity: 'error', detail: 'Что-то пошло не так', life: 3000 });
      }
    },
  },
});
</script>
